#include <stdio.h>



long getFileSize (char *);





void main (int argc, void ** argv)
{
long size;
FILE *in;
FILE *out;
char * fileBuffer;
long chunkCounter;
long i;

long uncompr_len;
long compr_len;
char * uncompr;
char chunkName[100];

if (argc != 2)
        {
        printf ("ERROR: This program must take one parameter (the file name)\n");
        return;
        }

size = getFileSize(argv[1]);

printf ("%s: %d bytes\n",argv[1],size);

if ( (in = fopen (argv[1],"rb")) == NULL  )
        {
        printf ("ERROR: Cannot open file %s.\n",argv[1]);
        return;
        }


if ( (fileBuffer = (char *) malloc (size)) == NULL)
        {
        printf ("ERROR: Cannot allocate memory.\n");
        return;
        }

fread (fileBuffer,size,1,in);
fclose (in);

/* After reading the file, i'll do a simple search for the "Def!" string
 * (which signals the compression) and decompress it into a separate file.
 * chunkCounter is used for the name of the files. In the near future 
 * chunk decompress will probably take place on the P2 IFF extractor itself.
 *
 * Mario "HCl" Brito
 */


for (i=0,chunkCounter=0; i<size; ++i)
        if ( fileBuffer[i]   == 'D' &&
             fileBuffer[i+1] == 'e' &&
             fileBuffer[i+2] == 'f' &&
             fileBuffer[i+3] == '!')

                {
                i +=4;
                uncompr_len =  * ((long *) (fileBuffer+i));
                i+=4;
                compr_len =  * ((long *) (fileBuffer+i));
                i+=4;
                if ( (uncompr = (char*) malloc (uncompr_len)) == NULL )
                        {
                        printf ("ERROR while allocating memory for chunk decompression (needed %x bytes)\n",uncompr_len);
                        return;
                        }
                uncompress(uncompr,&uncompr_len,fileBuffer+i,compr_len);
                i+=compr_len;
                sprintf (chunkName,"chunk%d",chunkCounter);
                if ((out = fopen (chunkName,"wb")) == NULL)
                        {
                        printf ("ERROR: Cannot create file\n");
                        return;
                        }
                fwrite (uncompr, uncompr_len,1,out);
                fclose (out);
                chunkCounter++;
                }


free (fileBuffer);

}










long getFileSize (char * name)
{
long size;
FILE * f;

f = fopen (name,"rb");
fseek (f,0L,SEEK_END);
size = ftell(f);
fclose (f);

return size;
}

